<?php
/*
Plugin Name: Bainternet Posts Creation Limits
Plugin URI: http://www.bainternet.info
Description: this plugin helps you to limit the number of posts/pages/custom post types each user can create on your site.
Version: 0.5.0
Author: באינטרנט בניית אתרים
Author URI: http://www.bainternet.info
*/
/*  Copyright 2011 באינטרנט בניית אתרים  (email : admin@bainternet.info)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

//get/register options and set defualt

//limit post type count per user
function bapl_limit_post_count(){
	global $pagenow , $current_user;
	
    if (is_admin() && $pagenow=='post-new.php'){
		$postt= bapl_getOptions('bapl');
		if (isset($_GET['post_type'])){
			$curent_type = $_GET['post_type'];
		}
		else
		{
			if($postt['post'] != 0){$curent_type = 'post';}
			else{return 0;}
		}
		
		get_currentuserinfo();
		if ( current_user_can('manage_options') ) {}else{ 
			if (isset($postt[$curent_type])){
				//$postt= bapl_getOptions('bapl');
				foreach ($postt as $key => $option){
					if ($key = $curent_type) {
						$ptname = $key;
						$limit = $option;
						break;
					}
				}
				//print_r($postt);
				$count_posts = count(get_posts(array('author'=>$current_user->ID,'post_type',$ptname)));
				
				if ($count_posts >= $limit){
					//wp_die( __('You Can\'t Create any more pages of this type.') );
					bapl_not_allowed();
					exit;
				}
			}
		}
	}
}

//hook limits check function to admin head.
add_action('admin_head','bapl_limit_post_count');


//add menu hook
add_action('admin_menu', 'bapl_menu');

//add menu function
function bapl_menu(){
	 // Add a new submenu under Settings:
    add_options_page(__('Posts Creation limits','Bainternet_WPSNFL'), __('Posts Creation limits','Bainternet_WPSNFL'), 'manage_options', __FILE__, 'bapl_settings_page');
}



//create options
add_action('admin_init', 'wpsnfl_init' );

function wpsnfl_init(){
	register_setting( 'bapl_Options', 'bapl' );
	bapl_getOptions();
}

//plugin settingd
function bapl_getOptions() {
			$temp = array();
			$post_types=get_post_types('','names');
			foreach ($post_types as $post_type ) {
				$temp[$post_type] = 0;
			}
			$getOptions = get_option('bapl');
            if (!empty($getOptions)) {
                foreach ($getOptions as $key => $option){
					 $temp[$key] = $option;
					
				}
			}            
            update_option('bapl', $temp);
            return $temp;
        }
		
//settings page
function bapl_settings_page()
{
	if (!current_user_can('manage_options'))  {wp_die( __('You do not have sufficient permissions to access this page.') );}
 	?>
	<div class="wrap">
		<h2><?php echo 'Bainternet Post Creation Limits'; ?> </h2>
		<form method="post" action="options.php">
			<?php settings_fields('bapl_Options'); ?>
			<?php $options = bapl_getOptions('bapl'); //get_option?>
			<p> 0 means unlimited!</p><br/>
			<table class="form-table">
			<tr valign="top">
				<td scope="row"><h3>post type</h3></th>
				<td scope="row"><h3>Limit Per User</h3></th>
			</tr>
			<?php
				$post_types=get_post_types('','names'); 
					foreach ($post_types as $post_type ) {?>
						<tr valign="top">
						<th scope="row"><?php echo $post_type; ?></th>
						<td><input name="bapl[<?php echo $post_type;?>]" type="input" value="<?php if (isset($options[$post_type])) {echo $options[$post_type];} else{ echo 0;} ?>"  /></td>
						</tr>
						<?php 
					}
				
				/*<tr valign="top"><th scope="row">Enable plugin?</th>
					<td><input name="bapl[enabled]" type="checkbox" value="1" <?php checked('1', $options['enabled']); ?> /></td>
				</tr>
				*/
				
				?>
				
			</table>
			<p class="submit">
			<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
			</p>
			<p> Curentlly set:</p>
			<p><?php 
			foreach ($options as $key => $val){
				echo $key . ' => ' .$val .'<br />';
			}
			?></p>
			
		
		</form>
	</div>
	<?php

}

// display error massage
function bapl_not_allowed(){
?>
<div class="wrap"><br />

<div id="message" class="error">You Can't Create any more pages of this type..</div>
</div>
<?php
}

?>